CON

' *******************************************************************************************************
' *                                                                                                     *
' *     Core PinDefs handling code - No ned to alter this                 PinDefs_Library_002.spin      *
' *                                                                                                     *
' *******************************************************************************************************

CON
  MAX_PIN = 31

VAR
  long pinUse[ MAX_PIN+1 ]
  byte pinName[ 8 ]
  byte clearedPins

PUB SetPin( strPtr, pinNumber )
  if clearedPins~~ == 0
    longfill( @pinUse, 0, MAX_PIN+1 )
    SetPin( String("I2C_SCL") , 28 )
    SetPin( String("I2C_SDA") , 29 )
    SetPin( String("TX_PROP") , 30 )
    SetPin( String("RX_PROP") , 31 ) 
  if pinNumber => 0 and pinNumber =< MAX_PIN
    pinUse[ pinNumber ] := GetPinTypeIdFromTypeIdName( strPtr )

PUB GetPinNumber( strPtr ) | pinTypeId, pinNumber
  pinTypeId := GetPinTypeIdFromTypeIdName( strPtr )
  repeat pinNumber from 0 to MAX_PIN
    if pinUse[ pinNumber ] == pinTypeId
      return pinNumber
  return -1

PUB GetPinName( pinNumber ) | pinTypeId
  if pinNumber => 0 and pinNumber =< MAX_PIN
    if ( pinTypeId := pinUse[ pinNumber ] )
      return GetPinTypeIdNameFromTypeId( pinTypeId )
    else
      return String("-")
  else
    return String("?")

PUB GetPinTypeIdFromTypeIdName( strPtr )
  return PackStringToLong( strPtr )

PUB GetPinTypeIdNameFromTypeId( pinTypeId )
  return UnpackLongToString( @pinName, pinTypeId )

PUB SaveToEeprom
 ' Not implemented

PRI PackStringToLong( strPtr ) | ch, chVal
  repeat StrSize( strPtr ) <# 7
    ch := byte[ strPtr++ ]
    if ch => "a" and ch =< "z"
      ch := ch - "a" + "A"
    if ( chVal := LookDown( ch : "A".."Z", "0".."3" ) )
      result := ( result << 5 ) | chVal

PRI UnpackLongToString( strPtr, value )
  result := strPtr
  if ( value <<= 2 )
    repeat while ( value >> 27 ) == 0
      value <<= 5
    repeat while value
      byte[ strPtr++ ] := LookUpZ( value >> 27 : "?", "A".."Z", "0".."3" )
      value <<= 5
  byte[ strPtr ] := 0

PUB Alias( strFromPtr, strToPtr )
  if long[ @result - $24 ] == 0
    long[ @result - $24 ]  := long[ @result - $20 ] 
  if StrComp( strFromPtr, long[ @result - $24 ] )
    long[ @result - $24 ] := strToPtr
    